"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");
_Object$defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
/**
 * similar to `useEffect` but gets triggered only when value changes
 * @param fn executable function on dependency updates
 * @param inputs dependency array
 */
const useDidUpdateEffect = (fn, inputs) => {
  const didMountRef = (0, _react.useRef)(false);
  (0, _react.useEffect)(() => {
    if (didMountRef.current) fn();else didMountRef.current = true;
  }, inputs);
};
var _default = useDidUpdateEffect;
exports.default = _default;