"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");
var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");
_Object$defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _react = require("react");
/*
 * copied from https://github.com/imbhargav5/rooks/blob/master/packages/shared/useKeyRef.ts
 */

const defaultOptions = {
  when: true,
  eventTypes: ['keydown']
};
/**
 * keyDown, keyPress 및 keyUp과 같은 키보드 이벤트에 대한 콜백을 실행합니다.
 *
 * @param input
 * @param callback
 * @param opts
 */
const useKey = (input, callback, opts) => {
  const keyList = (0, _react.useMemo)(() => (0, _isArray.default)(input) ? input : [input], [input]);
  const options = (0, _assign.default)({}, defaultOptions, opts);
  const {
    when,
    eventTypes
  } = options;
  const callbackRef = (0, _react.useRef)(callback);
  const {
    target
  } = options;
  (0, _react.useEffect)(() => {
    callbackRef.current = callback;
  });
  const handle = (0, _react.useCallback)(e => {
    if ((0, _some.default)(keyList).call(keyList, k => e.key === k || e.code === k)) {
      callbackRef.current(e);
    }
  }, [keyList]);
  (0, _react.useEffect)(() => {
    if (when && typeof window !== 'undefined') {
      const targetNode = target ? target['current'] : window;
      (0, _forEach.default)(eventTypes).call(eventTypes, eventType => {
        targetNode && targetNode.addEventListener(eventType, handle);
      });
      return () => {
        (0, _forEach.default)(eventTypes).call(eventTypes, eventType => {
          targetNode && targetNode.removeEventListener(eventType, handle);
        });
      };
    }
  }, [when, eventTypes, keyList, target, callback]);
};
var _default = useKey;
exports.default = _default;