"use strict";

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");
var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");
var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");
var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");
_Object$defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _jsxRuntime = require("@emotion/react/jsx-runtime");
var _react = require("react");
var Styled = _interopRequireWildcard(require("./Dropdown.styled"));
function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const DropdownItems = _ref => {
  var _context;
  let {
    data,
    style,
    onChange,
    onClose
  } = _ref;
  const Component = data.href ? 'a' : 'button';
  const hrefProps = Component === 'a' && {
    href: data.href,
    target: data.target
  };
  const [isShownSubMenu, setToggleSubMenu] = (0, _react.useState)(false);
  const ref = (0, _react.useRef)(null);
  const handleClickEvent = {
    toggleSubMenu: data => event => {
      if (!data.submenu || data.submenu && data.submenu.length === 0) {
        onChange && onChange(event.target.textContent, data);
        onClose && onClose();
        data.onClick && data.onClick();
      }
      setToggleSubMenu(!isShownSubMenu);
    },
    selectMenu: data => event => {
      onChange && onChange(event.target.textContent, data);
      onClose && onClose();
    },
    closeSubMenu: event => {
      if (ref.current && !ref.current.contains(event.target)) {
        setToggleSubMenu(false);
      }
    }
  };
  (0, _react.useEffect)(() => {
    document.addEventListener('click', handleClickEvent.closeSubMenu);
    return () => {
      document.removeEventListener('click', handleClickEvent.closeSubMenu);
    };
  }, []);
  return (0, _jsxRuntime.jsxs)(Styled.DropdownMenuItemWrapper, (0, _assign.default)({
    style: style,
    ref: ref
  }, {
    children: [(0, _jsxRuntime.jsxs)(Component, (0, _assign.default)({}, hrefProps, {
      type: "button",
      "aria-haspopup": "menu",
      "aria-expanded": "false",
      onClick: handleClickEvent.toggleSubMenu(data)
    }, {
      children: [(0, _jsxRuntime.jsx)("span", {
        children: data.title
      }), data.submenu && (0, _jsxRuntime.jsx)("svg", (0, _assign.default)({
        xmlns: "http://www.w3.org/2000/svg",
        width: "13",
        height: "8",
        viewBox: "0 0 13 8",
        fill: "none",
        className: "right-arrow"
      }, {
        children: (0, _jsxRuntime.jsx)("path", {
          d: "M1.06348 1.04015L6.98625 5.95435L12.3167 1.04015",
          stroke: "#616166",
          strokeWidth: "2"
        })
      }))]
    })), isShownSubMenu && data.submenu && data.submenu.length !== 0 && (0, _jsxRuntime.jsx)(Styled.DropdownArea, (0, _assign.default)({
      className: "dropdown-submenu"
    }, {
      children: (0, _map.default)(_context = data.submenu).call(_context, (item, index) => {
        return (0, _jsxRuntime.jsx)(Styled.DropdownMenuItems, {
          children: (0, _jsxRuntime.jsx)("button", (0, _assign.default)({
            type: "button",
            "aria-haspopup": "menu",
            "aria-expanded": "false",
            onClick: handleClickEvent.selectMenu(item)
          }, {
            children: (0, _jsxRuntime.jsx)("span", {
              children: item.title
            })
          }))
        }, index.toString());
      })
    }))]
  }));
};
const DropdownMenu = _ref2 => {
  let {
    selectedValue = '전체',
    data,
    cx,
    onChange,
    children
  } = _ref2;
  const [isShownDropdown, setToggleDropdown] = (0, _react.useState)(false);
  const ref = (0, _react.useRef)(null);
  const handleClickEvent = {
    toggleDropdown: () => setToggleDropdown(!isShownDropdown),
    closeDropdown: event => {
      if (ref.current && !ref.current.contains(event.target)) {
        setToggleDropdown(false);
      }
    },
    closeDropdownAction: () => {
      setToggleDropdown(false);
    }
  };
  (0, _react.useEffect)(() => {
    document.addEventListener('click', handleClickEvent.closeDropdown);
    return () => {
      document.removeEventListener('click', handleClickEvent.closeDropdown);
    };
  }, []);
  return (0, _jsxRuntime.jsx)(Styled.DropdownWrapper, (0, _assign.default)({
    ref: ref,
    css: cx
  }, {
    children: (0, _jsxRuntime.jsx)(Styled.DropdownMenus, {
      children: (0, _jsxRuntime.jsxs)(Styled.DropdownArea, {
        children: [(0, _jsxRuntime.jsxs)(Styled.DropdownMenuButton, (0, _assign.default)({
          type: "button",
          "aria-haspopup": "menu",
          "aria-expanded": "false",
          onClick: handleClickEvent.toggleDropdown
        }, {
          children: [(0, _jsxRuntime.jsx)(Styled.DropdownMenuTitle, {
            children: selectedValue
          }), (0, _jsxRuntime.jsx)("svg", (0, _assign.default)({
            width: "16",
            height: "16",
            viewBox: "0 0 16 16",
            fill: "none",
            xmlns: "http://www.w3.org/2000/svg"
          }, {
            children: (0, _jsxRuntime.jsx)("path", {
              d: "M11.5 6L8 10L4.5 6",
              stroke: "#424242",
              strokeWidth: "1.5",
              strokeLinecap: "square",
              strokeLinejoin: "round"
            })
          }))]
        })), data && data.length !== 0 && isShownDropdown && (0, _jsxRuntime.jsxs)(Styled.DropdownMenuItems, {
          children: [children && (0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
            children: [(0, _jsxRuntime.jsx)(Styled.DropdownMenuItemWrapper, (0, _assign.default)({
              "$hasChildren": true
            }, {
              children: children
            })), (0, _jsxRuntime.jsx)(Styled.Divider, {})]
          }), (0, _map.default)(data).call(data, (item, index) => {
            return (0, _jsxRuntime.jsx)(DropdownItems, {
              data: item,
              onChange: onChange,
              onClose: handleClickEvent.closeDropdownAction,
              onClick: item.onClick
            }, index.toString());
          })]
        })]
      })
    })
  }));
};
var _default = DropdownMenu;
exports.default = _default;