"use strict";

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");
var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");
var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");
var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");
_Object$defineProperty(exports, "__esModule", {
  value: true
});
exports.useMultiSelect = exports.MultiSelectProvider = void 0;
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _jsxRuntime = require("@emotion/react/jsx-runtime");
var _react = _interopRequireWildcard(require("react"));
function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const defaultStrings = {
  allItemsAreSelected: 'All items are selected.',
  clearSearch: 'Clear Search',
  clearSelected: 'Clear Selected',
  noOptions: 'No options',
  search: 'Search',
  selectAll: 'Select All',
  selectAllFiltered: 'Select All (Filtered)',
  selectSomeItems: 'Select...',
  create: 'Create'
};
const defaultProps = {
  value: [],
  hasSelectAll: true,
  debounceDuration: 200,
  options: []
};
const MultiSelectContext = /*#__PURE__*/_react.default.createContext({});
const MultiSelectProvider = _ref => {
  let {
    props,
    children
  } = _ref;
  const [options, setOptions] = (0, _react.useState)(props.options);
  const t = key => {
    var _a;
    return ((_a = props.overrideStrings) === null || _a === void 0 ? void 0 : _a[key]) || defaultStrings[key];
  };
  (0, _react.useEffect)(() => {
    setOptions(props.options);
  }, [props.options]);
  return (0, _jsxRuntime.jsx)(MultiSelectContext.Provider, (0, _assign.default)({
    value: (0, _assign.default)((0, _assign.default)((0, _assign.default)({
      t
    }, defaultProps), props), {
      options,
      setOptions
    })
  }, {
    children: children
  }));
};
exports.MultiSelectProvider = MultiSelectProvider;
const useMultiSelect = () => _react.default.useContext(MultiSelectContext);
exports.useMultiSelect = useMultiSelect;