"use strict";

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");
var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");
var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");
var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");
_Object$defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _jsxRuntime = require("@emotion/react/jsx-runtime");
var _react = require("react");
var _selectPanel = _interopRequireDefault(require("./selectPanel"));
var _header = require("./header");
var _MultiSelect = require("./MultiSelect.hooks");
var Styled = _interopRequireWildcard(require("./MultiSelect.styled"));
var _MultiSelect3 = require("./MultiSelect.constants");
var _MultiSelect4 = require("./MultiSelect.icons");
var _hooks = require("../@hooks");
function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const MultiSelectSelect = () => {
  const {
    t,
    onMenuToggle,
    ArrowRenderer,
    shouldToggleOnHover,
    isLoading,
    disabled,
    onChange,
    labelledBy,
    value,
    isOpen,
    defaultIsOpen,
    ClearSelectedIcon,
    closeOnChangedValue,
    direction = 'bottom',
    isError
  } = (0, _MultiSelect.useMultiSelect)();
  (0, _react.useEffect)(() => {
    if (closeOnChangedValue) setExpanded(false);
  }, [value]);
  const [isInternalExpand, setIsInternalExpand] = (0, _react.useState)(true);
  const [expanded, setExpanded] = (0, _react.useState)(defaultIsOpen);
  const [hasFocus, setHasFocus] = (0, _react.useState)(false);
  const FinalArrow = ArrowRenderer || _MultiSelect4.ArrowIcon;
  const wrapper = (0, _react.useRef)();
  (0, _hooks.useDidUpdateEffect)(() => {
    onMenuToggle && onMenuToggle(expanded);
  }, [expanded]);
  (0, _react.useEffect)(() => {
    if (defaultIsOpen === undefined && typeof isOpen === 'boolean') {
      setIsInternalExpand(false);
      setExpanded(isOpen);
    }
  }, [isOpen]);
  const handleKeyDown = e => {
    var _context, _context2;
    var _a;
    // allows space and enter when focused on input/button
    if ((0, _includes.default)(_context = ['text', 'button']).call(_context, e.target.type) && (0, _includes.default)(_context2 = [_MultiSelect3.KEY.SPACE, _MultiSelect3.KEY.ENTER]).call(_context2, e.code)) {
      return;
    }
    if (isInternalExpand) {
      if (e.code === _MultiSelect3.KEY.ESCAPE) {
        setExpanded(false);
        (_a = wrapper === null || wrapper === void 0 ? void 0 : wrapper.current) === null || _a === void 0 ? void 0 : _a.focus();
      } else {
        setExpanded(true);
      }
    }
    e.preventDefault();
  };
  (0, _hooks.useKey)([_MultiSelect3.KEY.ENTER, _MultiSelect3.KEY.ARROW_DOWN, _MultiSelect3.KEY.SPACE, _MultiSelect3.KEY.ESCAPE], handleKeyDown, {
    target: wrapper
  });
  const handleHover = isExpanded => {
    isInternalExpand && shouldToggleOnHover && setExpanded(isExpanded);
  };
  const handleFocus = () => !hasFocus && setHasFocus(true);
  const handleBlur = e => {
    if (!e.currentTarget.contains(e.relatedTarget) && isInternalExpand) {
      setHasFocus(false);
      setExpanded(false);
    }
  };
  const handleMouseEnter = () => handleHover(true);
  const handleMouseLeave = () => handleHover(false);
  const toggleExpanded = () => {
    isInternalExpand && setExpanded(isLoading || disabled ? false : !expanded);
  };
  const handleClearSelected = e => {
    e.stopPropagation();
    onChange([]);
    isInternalExpand && setExpanded(false);
  };
  return (0, _jsxRuntime.jsxs)(Styled.DSSelectWrapper, (0, _assign.default)({
    tabIndex: 0,
    "aria-labelledby": labelledBy,
    "aria-expanded": expanded,
    "aria-readonly": true,
    "aria-disabled": disabled,
    ref: wrapper,
    "$error": isError,
    onFocus: handleFocus,
    onBlur: handleBlur,
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave
  }, {
    children: [(0, _jsxRuntime.jsxs)(Styled.SelectHeadArea, (0, _assign.default)({
      onClick: toggleExpanded
    }, {
      children: [(0, _jsxRuntime.jsx)(_header.DropdownHeader, {}), isLoading && (0, _jsxRuntime.jsx)(_MultiSelect4.LoadingIcon, {}), value.length > 0 && ClearSelectedIcon !== null && (0, _jsxRuntime.jsx)("button", (0, _assign.default)({
        type: "button",
        onClick: handleClearSelected,
        disabled: disabled,
        "aria-label": t('clearSelected')
      }, {
        children: ClearSelectedIcon || (0, _jsxRuntime.jsx)(_MultiSelect4.CrossIcon, {})
      })), (0, _jsxRuntime.jsx)(Styled.SelectArrowWrapper, (0, _assign.default)({
        "$isOpen": expanded
      }, {
        children: (0, _jsxRuntime.jsx)(FinalArrow, {})
      }))]
    })), expanded && (0, _jsxRuntime.jsx)(Styled.SelectContent, (0, _assign.default)({
      "$direction": direction
    }, {
      children: (0, _jsxRuntime.jsx)(Styled.PanelContent, {
        children: (0, _jsxRuntime.jsx)(_selectPanel.default, {})
      })
    }))]
  }));
};
var _default = MultiSelectSelect;
exports.default = _default;