"use strict";

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");
var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");
var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");
var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");
_Object$defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _from = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/from"));
var _sign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/math/sign"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _startsWith = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/starts-with"));
var _jsxRuntime = require("@emotion/react/jsx-runtime");
var _react = _interopRequireDefault(require("react"));
var Styled = _interopRequireWildcard(require("./Pagination.styled"));
var _Pagination2 = require("./Pagination.icons");
function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf.default)(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols.default === "function") for (var i = 0, p = (0, _getOwnPropertySymbols.default)(s); i < p.length; i++) {
    if ((0, _indexOf.default)(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
const range = (start, end) => {
  var _context;
  const length = Math.abs(end - start) + 1;
  const {
    result
  } = (0, _reduce.default)(_context = (0, _from.default)({
    length
  })).call(_context, _ref => {
    let {
      result: temp,
      current
    } = _ref;
    return {
      result: [...temp, current],
      // eslint-disable-next-line @typescript-eslint/restrict-plus-operands
      current: current + (0, _sign.default)(end - start)
    };
  }, {
    current: start,
    result: []
  });
  return result;
};
const Waiting = () => (0, _jsxRuntime.jsx)(Styled.Waiting, {
  children: (0, _jsxRuntime.jsx)("svg", (0, _assign.default)({
    width: "12",
    height: "2",
    viewBox: "0 0 12 2",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, {
    children: (0, _jsxRuntime.jsx)("path", {
      fillRule: "evenodd",
      clipRule: "evenodd",
      d: "M10 1C10 0.447715 10.4477 -1.35705e-07 11 -8.74228e-08C11.5523 -3.91405e-08 12 0.447715 12 1C12 1.55228 11.5523 2 11 2C10.4477 2 10 1.55228 10 1ZM5 0.999999C5 0.447715 5.44772 -5.72819e-07 6 -5.24537e-07C6.55228 -4.76254e-07 7 0.447715 7 1C7 1.55228 6.55228 2 6 2C5.44772 2 5 1.55228 5 0.999999ZM1 -9.61651e-07C0.447715 -1.00993e-06 1.35705e-07 0.447714 8.74228e-08 0.999999C3.91405e-08 1.55228 0.447715 2 1 2C1.55229 2 2 1.55228 2 0.999999C2 0.447714 1.55229 -9.13368e-07 1 -9.61651e-07Z",
      fill: "#A5ABBA"
    })
  }))
});
const Page = _ref2 => {
  let {
    size = 'large',
    currentPageNumber,
    pageNumber,
    onClick
  } = _ref2;
  const selected = currentPageNumber === pageNumber;
  const handleClickPage = _react.default.useCallback(() => {
    onClick(pageNumber);
  }, [onClick, pageNumber]);
  return (0, _jsxRuntime.jsx)(Styled.Page, (0, _assign.default)({
    "$size": size,
    "$selected": selected,
    onClick: handleClickPage
  }, {
    children: pageNumber
  }));
};
const parseTotalPage = (maxPageNumber, currentPageNumber) => maxPageNumber === 0 || maxPageNumber < currentPageNumber ? currentPageNumber : maxPageNumber;
/**
 *
 * @param type
 * @param size
 * @param page 선택된 페이지
 * @param totalPage 총 페이지
 * @param visiblePageList 보여질 페이지의 개수
 * @param onChangePage
 * @constructor
 */
const Pagination = _a => {
  var _context2;
  var {
      type = 'default',
      size = 'large',
      page = 1,
      totalPage = 1,
      visiblePageList = 5,
      onChangePage
    } = _a,
    rest = __rest(_a, ["type", "size", "page", "totalPage", "visiblePageList", "onChangePage"]);
  const totalVisiblePage = parseTotalPage(totalPage, page);
  const handleClickPage = _react.default.useCallback(nextPage => {
    onChangePage(nextPage, 'page');
  }, [onChangePage]);
  const handleClickPrev = _react.default.useCallback(() => {
    const prevPage = page - 1;
    if (prevPage < 1) return;
    onChangePage(prevPage, 'prev');
  }, [onChangePage, page]);
  const handleClickNext = _react.default.useCallback(() => {
    const nextPage = page + 1;
    if (nextPage > totalVisiblePage) return;
    onChangePage(nextPage, 'next');
  }, [totalVisiblePage, onChangePage, page]);
  const visiblePages = _react.default.useCallback(isApply => {
    const currentPageList = Math.ceil(page / visiblePageList);
    const startPage = (currentPageList - 1) * visiblePageList + 1;
    const endPage = currentPageList * visiblePageList;
    let tempPageList = range(startPage, endPage > totalVisiblePage ? totalVisiblePage : endPage);
    if (isApply === 'small') return tempPageList;
    if (startPage !== 1) {
      tempPageList = [1, 'waiting-start', ...tempPageList];
    }
    if (endPage < totalVisiblePage) {
      tempPageList = [...tempPageList, 'waiting-end', totalVisiblePage];
    }
    return tempPageList;
  }, [totalVisiblePage, visiblePageList, page]);
  const disabledPrevBtn = page < 2;
  const disabledNextBtn = page + 1 > totalVisiblePage;
  return (0, _jsxRuntime.jsxs)(Styled.DSPaginationWrapper, (0, _assign.default)({
    "$type": type,
    "$size": size
  }, rest, {
    children: [(0, _jsxRuntime.jsx)(Styled.PrevButton, (0, _assign.default)({
      "$disabled": disabledPrevBtn,
      onClick: handleClickPrev
    }, {
      children: (0, _jsxRuntime.jsx)(_Pagination2.Icon20NavigationArrPrev, {})
    })), (0, _jsxRuntime.jsx)(Styled.Pages, {
      children: (0, _map.default)(_context2 = visiblePages(size)).call(_context2, pageNumber => {
        var _context3;
        return (0, _startsWith.default)(_context3 = `${pageNumber}`).call(_context3, 'waiting') ? (0, _jsxRuntime.jsx)(Waiting, {}, `page-${pageNumber}`) : (0, _jsxRuntime.jsx)(Page, {
          size: size,
          currentPageNumber: page,
          pageNumber: pageNumber,
          onClick: handleClickPage
        }, `page-${pageNumber}`);
      })
    }), (0, _jsxRuntime.jsx)(Styled.NextButton, (0, _assign.default)({
      "$disabled": disabledNextBtn,
      onClick: handleClickNext
    }, {
      children: (0, _jsxRuntime.jsx)(_Pagination2.Icon20NavigationArrNext, {})
    }))]
  }));
};
var _default = Pagination;
exports.default = _default;