import { Ref } from 'react';
interface Options {
    /**
     * Condition which if true, will enable the event listeners
     */
    when?: boolean;
    /**
     * Keyboardevent types to listen for. Valid options are keyDown, keyPress and keyUp
     */
    eventTypes?: Array<string | number>;
    /**
     * target ref on which the events should be listened. If no target is specified,
     * events are listened to on the window
     */
    target?: Ref<HTMLElement> | null;
}
/**
 * keyDown, keyPress 및 keyUp과 같은 키보드 이벤트에 대한 콜백을 실행합니다.
 *
 * @param input
 * @param callback
 * @param opts
 */
declare const useKey: (input: string | number | (string | number)[], callback: (e: KeyboardEvent) => any, opts?: Options) => void;
export default useKey;
