import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _spliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/splice";
import _sortInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/sort";
import _findIndexInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/find-index";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import { jsx as _jsx } from "@emotion/react/jsx-runtime";
import React from 'react';
import classNames from 'classnames';
import Checkbox from './Checkbox';
import { ConfigContext, GroupContext } from './Checkbox.context';
function omit(obj, fields) {
  const clone = _Object$assign({}, obj);
  if (_Array$isArray(fields)) {
    _forEachInstanceProperty(fields).call(fields, key => {
      delete clone[key];
    });
  }
  return clone;
}
const InternalCheckboxGroup = (_a, ref) => {
  var {
      defaultValue,
      children,
      options = [],
      prefixCls: customizePrefixCls,
      className,
      style,
      onChange
    } = _a,
    restProps = __rest(_a, ["defaultValue", "children", "options", "prefixCls", "className", "style", "onChange"]);
  const {
    getPrefixCls,
    direction
  } = React.useContext(ConfigContext);
  const [value, setValue] = React.useState(restProps.value || defaultValue || []);
  const [registeredValues, setRegisteredValues] = React.useState([]);
  React.useEffect(() => {
    if ('value' in restProps) {
      setValue(restProps.value || []);
    }
  }, [restProps.value]);
  const getOptions = () => _mapInstanceProperty(options).call(options, option => {
    if (typeof option === 'string' || typeof option === 'number') {
      return {
        label: option,
        value: option
      };
    }
    return option;
  });
  const cancelValue = val => {
    setRegisteredValues(prevValues => _filterInstanceProperty(prevValues).call(prevValues, v => v !== val));
  };
  const registerValue = val => {
    setRegisteredValues(prevValues => [...prevValues, val]);
  };
  const toggleOption = option => {
    var _context;
    const optionIndex = _indexOfInstanceProperty(value).call(value, option.value);
    const newValue = [...value];
    if (optionIndex === -1) {
      newValue.push(option.value);
    } else {
      _spliceInstanceProperty(newValue).call(newValue, optionIndex, 1);
    }
    if (!('value' in restProps)) {
      setValue(newValue);
    }
    const opts = getOptions();
    onChange === null || onChange === void 0 ? void 0 : onChange(_sortInstanceProperty(_context = _filterInstanceProperty(newValue).call(newValue, val => _indexOfInstanceProperty(registeredValues).call(registeredValues, val) !== -1)).call(_context, (a, b) => {
      const indexA = _findIndexInstanceProperty(opts).call(opts, opt => opt.value === a);
      const indexB = _findIndexInstanceProperty(opts).call(opts, opt => opt.value === b);
      return indexA - indexB;
    }));
  };
  const prefixCls = getPrefixCls('checkbox', customizePrefixCls);
  const groupPrefixCls = `${prefixCls}-group`;
  const domProps = omit(restProps, ['value', 'disabled']);
  if (options && options.length > 0) {
    var _context2;
    children = _mapInstanceProperty(_context2 = getOptions()).call(_context2, option => _jsx(Checkbox, _Object$assign({
      prefixCls: prefixCls,
      disabled: 'disabled' in option ? option.disabled : restProps.disabled,
      value: option.value,
      checked: _indexOfInstanceProperty(value).call(value, option.value) !== -1,
      onChange: option.onChange,
      className: `${groupPrefixCls}-item`,
      style: option.style
    }, {
      children: option.label
    }), option.value.toString()));
  }
  const context = {
    toggleOption,
    value,
    disabled: restProps.disabled,
    name: restProps.name,
    // https://github.com/ant-design/ant-design/issues/16376
    registerValue,
    cancelValue
  };
  const classString = classNames(groupPrefixCls, {
    [`${groupPrefixCls}-rtl`]: direction === 'rtl'
  }, className);
  return _jsx("div", _Object$assign({
    className: classString,
    style: style
  }, domProps, {
    ref: ref
  }, {
    children: _jsx(GroupContext.Provider, _Object$assign({
      value: context
    }, {
      children: children
    }))
  }));
};
const CheckboxGroup = /*#__PURE__*/React.forwardRef(InternalCheckboxGroup);
export default /*#__PURE__*/React.memo(CheckboxGroup);