import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _findInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/find";
import { jsx as _jsx, Fragment as _Fragment } from "@emotion/react/jsx-runtime";
import { useMultiSelect } from '../MultiSelect.hooks';
import SelectItem from '../selectItem';
const SelectList = _ref => {
  let {
    options,
    onClick,
    skipIndex,
    isCheckboxShowing,
    closeOnChangedValue
  } = _ref;
  const {
    disabled,
    value,
    onChange,
    ItemRenderer
  } = useMultiSelect();
  const handleSelectionChanged = (option, checked) => {
    if (disabled) return;
    if (!isCheckboxShowing && closeOnChangedValue) {
      return onChange([option]);
    }
    onChange(checked ? [...value, option] : _filterInstanceProperty(value).call(value, o => o.value !== option.value));
  };
  return _jsx(_Fragment, {
    children: _mapInstanceProperty(options).call(options, (o, i) => {
      const tabIndex = i + skipIndex;
      return _jsx("li", {
        children: _jsx(SelectItem, {
          tabIndex: tabIndex,
          option: o,
          onSelectionChanged: c => handleSelectionChanged(o, c),
          checked: !!_findInstanceProperty(value).call(value, s => s.value === o.value),
          onClick: e => onClick(e, tabIndex),
          itemRenderer: ItemRenderer,
          disabled: o.disabled || disabled,
          isCheckboxShowing: isCheckboxShowing
        })
      }, (o === null || o === void 0 ? void 0 : o.key) || i);
    })
  });
};
export default SelectList;