import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "@emotion/react/jsx-runtime";
import React from 'react';
import { CharLimit } from '../CharLimit';
import { Icon24Search } from './Input.icons';
import { Icon20Alert } from '../Icon';
import * as Styled from './Input.styled';
import { Asterisk } from '../../Asterisk';
import { HelperText } from '../../HelperText';
const Input = /*#__PURE__*/React.forwardRef((_a, ref) => {
  var {
      value,
      defaultValue = '',
      type = 'text',
      width = '100%',
      inputSize = 'large',
      label,
      description,
      innerLabel,
      placeholder,
      unitText,
      helperText = '',
      errorText = '',
      charLimit,
      textAlignRight = false,
      mustInput = false,
      isError = false,
      disabled = false,
      onBlur,
      onChange,
      onClick,
      onFocus,
      onKeyDown,
      onKeyUp,
      disableEnterSubmit = false,
      isSearch,
      prefixIcon,
      suffixIcon,
      style,
      autoComplete
    } = _a,
    rest = __rest(_a, ["value", "defaultValue", "type", "width", "inputSize", "label", "description", "innerLabel", "placeholder", "unitText", "helperText", "errorText", "charLimit", "textAlignRight", "mustInput", "isError", "disabled", "onBlur", "onChange", "onClick", "onFocus", "onKeyDown", "onKeyUp", "disableEnterSubmit", "isSearch", "prefixIcon", "suffixIcon", "style", "autoComplete"]);
  const [, setFocus] = React.useState(false);
  const [inputValue, setInputValue] = React.useState(defaultValue);
  const length = inputValue.length || 0;
  const hasError = isError || !!(charLimit && length > charLimit);
  const hasFooterText = !!helperText || hasError && !!errorText;
  const showInnerLabel = innerLabel;
  const showSearchIcon = isSearch && !isError;
  const handleChange = event => {
    setInputValue(event.target.value);
    if (!disabled && typeof onChange === 'function') {
      onChange(event);
    }
  };
  const handleClick = event => {
    if (!disabled && typeof onClick === 'function') {
      onClick(event);
    }
  };
  const handleFocus = event => {
    if (!disabled && typeof onFocus === 'function') {
      onFocus(event);
      setFocus(true);
    }
  };
  const handleBlur = event => {
    if (!disabled && typeof onBlur === 'function') {
      onBlur(event);
      setFocus(false);
    }
  };
  const handleKeyDown = event => {
    if (disableEnterSubmit) {
      if (event.key === 'Enter') {
        event.preventDefault();
      }
    }
    if (!disabled && typeof onKeyDown === 'function') {
      onKeyDown(event);
    }
  };
  const handleKeyUp = event => {
    if (!disabled && typeof onKeyUp === 'function') {
      onKeyUp(event);
    }
  };
  return _jsxs(Styled.DSInputWrapper, _Object$assign({
    style: style,
    "$width": width
  }, {
    children: [(label || charLimit || description) && _jsxs(_Fragment, {
      children: [_jsxs(Styled.LabelWrapper, _Object$assign({
        "$noLabel": !label
      }, {
        children: [label && _jsxs(Styled.Label, {
          children: [label, mustInput && _jsx(Asterisk, {})]
        }), charLimit && _jsx(CharLimit, {
          noLabel: !label,
          length: length,
          charLimit: charLimit
        })]
      })), description && _jsx(Styled.Description, {
        children: description
      })]
    }), _jsxs(Styled.InputBorder, _Object$assign({
      "$isError": hasError,
      "$isExistsValue": !!inputValue,
      "$disabled": disabled,
      "$inputSize": inputSize,
      "$isSearch": !!isSearch
    }, {
      children: [prefixIcon && _jsx(Styled.IconWrapper, {
        isIconOnly: true,
        icon: prefixIcon
      }), _jsxs(Styled.InputContents, {
        children: [showInnerLabel && _jsx(Styled.InnerLabel, {
          children: innerLabel
        }), _jsx(Styled.Input, _Object$assign({}, rest, {
          ref: ref,
          value: value !== null && value !== void 0 ? value : inputValue,
          type: type,
          placeholder: placeholder,
          readOnly: disabled,
          onChange: handleChange,
          onFocus: handleFocus,
          onBlur: handleBlur,
          onKeyDown: handleKeyDown,
          onKeyUp: handleKeyUp,
          autoComplete: autoComplete,
          "$disabled": disabled,
          "$textAlignRight": textAlignRight
        }))]
      }), unitText && _jsx(Styled.UnitText, {
        children: unitText
      }), _jsxs("span", _Object$assign({
        "aria-hidden": "true",
        onClick: handleClick
      }, {
        children: [showSearchIcon && _jsx(Icon24Search, {}), hasError && _jsx(Icon20Alert, {}), !showSearchIcon && !hasError && _jsx(Styled.IconWrapper, {
          isIconOnly: true,
          icon: suffixIcon
        })]
      }))]
    })), hasFooterText && _jsx(HelperText, _Object$assign({
      color: hasError ? 'error' : 'gray'
    }, {
      children: hasError ? errorText : helperText
    }))]
  }));
});
export default Input;