declare const normalize = "\n  /*! sanitize.css v7.0.3 | CC0 License | github.com/csstools/sanitize.css */\n\n  /* Document\n     * ========================================================================== */\n\n  /**\n     * 1. Remove repeating backgrounds in all browsers (opinionated).\n     * 2. Add border box sizing in all browsers (opinionated).\n     */\n\n  *,\n  ::before,\n  ::after {\n    background-repeat: no-repeat; /* 1 */\n    box-sizing: border-box; /* 2 */\n  }\n\n  /**\n     * 1. Add text decoration inheritance in all browsers (opinionated).\n     * 2. Add vertical alignment inheritance in all browsers (opinionated).\n     */\n\n  ::before,\n  ::after {\n    text-decoration: inherit; /* 1 */\n    vertical-align: inherit; /* 2 */\n  }\n\n  /**\n     * 1. Use the default cursor in all browsers (opinionated).\n     * 2. Use the default user interface font in all browsers (opinionated).\n     * 3. Correct the line height in all browsers.\n     * 4. Use a 4-space tab width in all browsers (opinionated).\n     * 5. Prevent adjustments of font size after orientation changes in\n     *    IE on Windows Phone and in iOS.\n     * 6. Breaks words to prevent overflow in all browsers (opinionated).\n     */\n\n  html {\n    cursor: default; /* 1 */\n    font-family: 'Spoqa Han Sans', sans-serif !important;\n\n    line-height: 1.15; /* 3 */\n    -moz-tab-size: 4; /* 4 */\n    tab-size: 4; /* 4 */\n    -ms-text-size-adjust: 100%; /* 5 */\n    -webkit-text-size-adjust: 100%; /* 5 */\n    word-break: break-word; /* 6 */\n  }\n\n  /* Sections\n     * ========================================================================== */\n\n  /**\n     * Remove the margin in all browsers (opinionated).\n     */\n\n  body {\n    margin: 0;\n  }\n\n  h1 {\n    font-size: 2em;\n    margin: 0;\n  }\n  \n  h2,\n  h3,\n  h4,\n  h5,\n  h6 {\n    margin: 0;\n  }\n\n  /* Grouping content\n     * ========================================================================== */\n\n  /**\n     * 1. Add the correct sizing in Firefox.\n     * 2. Show the overflow in Edge and IE.\n     */\n\n  hr {\n    height: 0; /* 1 */\n    overflow: visible; /* 2 */\n  }\n\n  /**\n     * Add the correct display in IE.\n     */\n\n  main {\n    display: block;\n  }\n\n  /**\n     * Remove the list style on navigation lists in all browsers (opinionated).\n     */\n\n  nav ol,\n  nav ul {\n    list-style: none;\n  }\n\n  pre {\n    font-family: 'Spoqa Han Sans', sans-serif !important;\n    font-size: 1em; /* 2 */\n  }\n\n  /* Text-level semantics\n     * ========================================================================== */\n\n  /**\n     * Remove the gray background on active links in IE 10.\n     */\n\n  a {\n    background-color: transparent;\n    text-decoration: none;\n    color: unset;\n  }\n\n  /**\n     * Add the correct text decoration in Edge, IE, Opera, and Safari.\n     */\n\n  abbr[title] {\n    text-decoration: underline dotted;\n  }\n\n  code,\n  kbd,\n  samp {\n    font-family: 'Spoqa Han Sans', sans-serif !important;\n    font-size: 1em; /* 2 */\n  }\n\n  /**\n     * Add the correct font size in all browsers.\n     */\n\n  small {\n    font-size: 80%;\n  }\n\n  /*\n     * Remove the text shadow on text selections in Firefox 61- (opinionated).\n     * 1. Restore the coloring undone by defining the text shadow\n     *    in all browsers (opinionated).\n     */\n\n  ::-moz-selection {\n    background-color: #b3d4fc; /* 1 */\n    color: #000; /* 1 */\n    text-shadow: none;\n  }\n\n  ::selection {\n    background-color: #b3d4fc; /* 1 */\n    color: #000; /* 1 */\n    text-shadow: none;\n  }\n\n  /* Embedded content\n     * ========================================================================== */\n\n  /*\n     * Change the alignment on media elements in all browers (opinionated).\n     */\n\n  audio,\n  canvas,\n  iframe,\n  img,\n  svg,\n  video {\n    vertical-align: middle;\n  }\n\n  /**\n     * Add the correct display in IE 9-.\n     */\n\n  audio,\n  video {\n    display: inline-block;\n  }\n\n  /**\n     * Add the correct display in iOS 4-7.\n     */\n\n  audio:not([controls]) {\n    display: none;\n    height: 0;\n  }\n\n  /**\n     * Remove the border on images inside links in IE 10-.\n     */\n\n  img {\n    border-style: none;\n  }\n\n  /**\n     * Change the fill color to match the text color in all browsers (opinionated).\n     */\n\n  svg:not([fill]) {\n    fill: currentColor;\n  }\n\n  /**\n     * Hide the overflow in IE.\n     */\n\n  svg:not(:root) {\n    overflow: hidden;\n  }\n\n  /* Tabular data\n     * ========================================================================== */\n\n  /**\n     * Collapse border spacing in all browsers (opinionated).\n     */\n\n  table {\n    border-collapse: collapse;\n  }\n\n  /* Forms\n     * ========================================================================== */\n\n  /**\n     * Inherit styling in all browsers (opinionated).\n     */\n\n  button,\n  input,\n  select,\n  textarea {\n    font-family: inherit;\n    font-size: inherit;\n    line-height: inherit;\n    padding: 0;\n    border: 0;\n  }\n\n  /**\n     * Remove the margin in Safari.\n     */\n\n  button,\n  input,\n  select {\n    margin: 0;\n  }\n\n  /**\n     * 1. Show the overflow in IE.\n     * 2. Remove the inheritance of text transform in Edge, Firefox, and IE.\n     */\n\n  button {\n    background-color: transparent;\n    overflow: visible; /* 1 */\n    text-transform: none; /* 2 */\n  }\n\n  /**\n     * Correct the inability to style clickable types in iOS and Safari.\n     */\n\n  button,\n  [type='button'],\n  [type='reset'],\n  [type='submit'] {\n    -webkit-appearance: button;\n  }\n\n  /**\n     * Correct the padding in Firefox.\n     */\n\n  fieldset {\n    padding: 0.35em 0.75em 0.625em;\n  }\n\n  /**\n     * Show the overflow in Edge and IE.\n     */\n\n  input {\n    overflow: visible;\n  }\n\n  legend {\n    color: inherit; /* 2 */\n    display: table; /* 1 */\n    max-width: 100%; /* 1 */\n    white-space: normal; /* 1 */\n  }\n\n  /**\n     * 1. Add the correct display in Edge and IE.\n     * 2. Add the correct vertical alignment in Chrome, Firefox, and Opera.\n     */\n\n  progress {\n    display: inline-block; /* 1 */\n    vertical-align: baseline; /* 2 */\n  }\n\n  /**\n     * Remove the inheritance of text transform in Firefox.\n     */\n\n  select {\n    text-transform: none;\n  }\n\n  /**\n     * 1. Remove the margin in Firefox and Safari.\n     * 2. Remove the default vertical scrollbar in IE.\n     * 3. Change the resize direction on textareas in all browsers (opinionated).\n     */\n\n  textarea {\n    margin: 0; /* 1 */\n    overflow: auto; /* 2 */\n    resize: vertical; /* 3 */\n  }\n\n  /**\n     * Remove the padding in IE 10-.\n     */\n\n  [type='checkbox'],\n  [type='radio'] {\n    padding: 0;\n  }\n\n  /**\n     * 1. Correct the odd appearance in Chrome and Safari.\n     * 2. Correct the outline style in Safari.\n     */\n\n  [type='search'] {\n    -webkit-appearance: textfield; /* 1 */\n    outline-offset: -2px; /* 2 */\n  }\n\n  /**\n     * Correct the cursor style of increment and decrement buttons in Safari.\n     */\n\n  ::-webkit-inner-spin-button,\n  ::-webkit-outer-spin-button {\n    height: auto;\n  }\n\n  /**\n     * Correct the text style of placeholders in Chrome, Edge, and Safari.\n     */\n\n  ::-webkit-input-placeholder {\n    color: inherit;\n    opacity: 1;\n  }\n\n  /**\n     * Remove the inner padding in Chrome and Safari on macOS.\n     */\n\n  ::-webkit-search-decoration {\n    -webkit-appearance: none;\n  }\n\n  ::-webkit-file-upload-button {\n    -webkit-appearance: button; /* 1 */\n    font: inherit; /* 2 */\n  }\n\n  /**\n     * Remove the inner border and padding of focus outlines in Firefox.\n     */\n\n  ::-moz-focus-inner {\n    border-style: none;\n    padding: 0;\n  }\n\n  /**\n     * Restore the focus outline styles unset by the previous rule in Firefox.\n     */\n\n  :-moz-focusring {\n    outline: 1px dotted ButtonText;\n  }\n\n  /* Interactive\n     * ========================================================================== */\n\n  /*\n     * Add the correct display in Edge and IE.\n     */\n\n  details {\n    display: block;\n  }\n\n  /*\n     * Add the correct styles in Edge, IE, and Safari.\n     */\n\n  dialog {\n    background-color: white;\n    border: solid;\n    color: black;\n    display: block;\n    height: fit-content;\n    left: 0;\n    margin: auto;\n    padding: 1em;\n    position: absolute;\n    right: 0;\n    width: -moz-fit-content;\n    width: fit-content;\n  }\n\n  dialog:not([open]) {\n    display: none;\n  }\n\n  /*\n     * Add the correct display in all browsers.\n     */\n\n  summary {\n    display: list-item;\n  }\n\n  /* Scripting\n     * ========================================================================== */\n\n  /**\n     * Add the correct display in IE 9-.\n     */\n\n  canvas {\n    display: inline-block;\n  }\n\n  /**\n     * Add the correct display in IE.\n     */\n\n  template {\n    display: none;\n  }\n\n  /* User interaction\n     * ========================================================================== */\n\n  /*\n     * 1. Remove the tapping delay in IE 10.\n     * 2. Remove the tapping delay on clickable elements\n          in all browsers (opinionated).\n     */\n\n  a,\n  area,\n  button,\n  input,\n  label,\n  select,\n  summary,\n  textarea,\n  [tabindex] {\n    -ms-touch-action: manipulation; /* 1 */\n    touch-action: manipulation; /* 2 */\n  }\n\n  /**\n     * Add the correct display in IE 10-.\n     */\n\n  [hidden] {\n    display: none;\n  }\n\n  /* Accessibility\n     * ========================================================================== */\n\n  /**\n     * Change the cursor on busy elements in all browsers (opinionated).\n     */\n\n  [aria-busy='true'] {\n    cursor: progress;\n  }\n\n  /*\n     * Change the cursor on control elements in all browsers (opinionated).\n     */\n\n  [aria-controls] {\n    cursor: pointer;\n  }\n\n  /*\n     * Change the cursor on disabled, not-editable, or otherwise\n     * inoperable elements in all browsers (opinionated).\n     */\n\n  [aria-disabled='true'],\n  [disabled] {\n    cursor: not-allowed;\n  }\n\n  /*\n     * Change the display on visually hidden accessible elements\n     * in all browsers (opinionated).\n     */\n\n  [aria-hidden='false'][hidden]:not(:focus) {\n    clip: rect(0, 0, 0, 0);\n    display: inherit;\n    position: absolute;\n  }\n  \n  input[type=range] {\n    -webkit-appearance: none; /* Hides the slider so that custom slider can be made */\n    width: 100%; /* Specific width is required for Firefox. */\n    background: transparent; /* Otherwise white in Chrome */\n  }\n\n  input[type=range]::-webkit-slider-thumb {\n    -webkit-appearance: none;\n  }\n\n  input[type=range]:focus {\n    outline: none; /* Removes the blue border. You should probably do some kind of focus styling for accessibility reasons though. */\n  }\n\n  input[type=range]::-ms-track {\n    width: 100%;\n    cursor: pointer;\n\n    /* Hides the slider so custom styles can be added */\n    background: transparent; \n    border-color: transparent;\n    color: transparent;\n  }\n";
export default normalize;
